ALTER TABLE tasks ADD COLUMN deadline date;
alter table tasks alter column deadline set default now();


DROP FUNCTION IF EXISTS public.GetTaskDeadline(psubject character varying, psubmodulenum integer, psemester integer, pnick character varying, pservice character varying);
CREATE OR REPLACE FUNCTION public.GetTaskDeadline(psubject character varying, psubmodulenum integer, psemester integer, pnick character varying, pservice character varying)
    RETURNS integer
    LANGUAGE plpgsql
AS $function$
DECLARE vRecordBookID integer DEFAULT NULL;
        vDisciplineID integer DEFAULT NULL;
        vDeadLine DATE default NULL;

BEGIN

    SELECT D."RecordBookID", D."DisciplineID"  into vRecordBookID, vDisciplineID
    FROM getrecordbookforsubjectandnick(pnick, psubject, psemester, pservice) AS D;

    SELECT tasks.DeadLine into vDeadLine
    FROM tasks
        WHERE tasks.RecordBookID = vRecordBookID
          AND tasks.DisciplineID = vDisciplineID
          AND tasks.ModuleNumber = psubmodulenum;
    RETURN vDeadLine;
EXCEPTION
    when others
        then RETURN NULL;
end
$function$;

DROP FUNCTION IF EXISTS public.SetTaskDeadline(pdiscipline integer, psubmodulenum integer, pdeadline date);
CREATE OR REPLACE FUNCTION public.SetTaskDeadline(pdiscipline integer, psubmodulenum integer, pdeadline date)
    RETURNS integer
    LANGUAGE plpgsql
AS $function$
BEGIN

    UPDATE tasks SET deadline = pdeadline
    WHERE tasks.disciplineid = pdiscipline
      AND tasks.modulenumber = psubmodulenum;

    RETURN 0;

end
$function$;

DROP FUNCTION IF EXISTS public.CheckTaskDeadline(pdiscipline integer, psubmodulenum integer, precordbook integer);
CREATE OR REPLACE FUNCTION public.CheckTaskDeadline(pdiscipline integer, psubmodulenum integer, precordbook integer)
    RETURNS bool
    LANGUAGE plpgsql
AS $function$
DECLARE vDeadline DATE DEFAULT NULL;
BEGIN

    SELECT tasks.Deadline into vDeadline
    FROM tasks
    WHERE tasks.DisciplineID = pdiscipline
      AND tasks.ModuleNumber = psubmodulenum
      AND tasks.RecordBookID = precordbook;
    if vDeadline is null
    then
        return true;
    end if;

    RETURN vDeadline > now();

end
$function$;