DROP FUNCTION IF EXISTS public.logformexport(paccountid integer, pdisciplineid character varying, pgroupid integer, psemesterid integer, perror integer);
CREATE OR REPLACE FUNCTION public.logformexport(paccountid integer, pdisciplineid character varying, pgroupid integer, psemesterid integer, perror integer)
    RETURNS integer
    LANGUAGE plpgsql
AS $function$
DECLARE vDisciplineID integer default -1;
begin
    select disciplinesForGroup."ID" into vDisciplineID from
        (select D."ID" as "ID",
                D."SubjectName" as "SubjectName",
                subjects.externalid as "DisciplineExternalID"
         from public.getdisciplinesforgroup(pgroupid, psemesterid) as D
                  join disciplines on disciplines.id = D."ID"
                  join subjects on disciplines.subjectid = subjects.id) as disciplinesForGroup
    WHERE disciplinesForGroup."DisciplineExternalID" = pdisciplineid;
     IF vDisciplineID != -1 THEN
        INSERT INTO logs_form_export (discipline_id, group_id, account_id, semester_id, error) VALUES (vDisciplineID, pgroupid, paccountid, psemesterid, perror);
     END IF;
    RETURN 0;
END
$function$;
